c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine bnddef(iunit,nx,ny,istr,iend,jstr,jend)
c
c-----ATDM v1.00
c
c     Reads domain boundary definition from BOUNDARY file
c
c-----95/06/01:
c     -from UAM-V Revision 1.2  94/02/10  20:50:45  tcm
c
c     Input arguments:
c               iunit:          boundary condition file unit number   
c               nx:             number of coarse grid cells in x-direction
c               ny:             number of coarse grid cells in y-direction
c     Output arguments:
c               istr:           array of starting i-cell indices
c               iend:           array of ending i-cell indices
c               jstr:           array of starting j-cell indices
c               jend:           array of ending j-cell indices
c     Files read:
c               iunit:          boundary condition file
c     Called by:
c               setup
c
      dimension istr(ny), iend(ny), jstr(nx), jend(nx)
c
      read (iunit) idum,idum,nc,(istr(i),idum,idum,idum,i=1,nc)
      read (iunit) idum,idum,nc,(iend(i),idum,idum,idum,i=1,nc)
      read (iunit) idum,idum,nc,(jstr(i),idum,idum,idum,i=1,nc)
      read (iunit) idum,idum,nc,(jend(i),idum,idum,idum,i=1,nc)
c
      do 50 i=1,ny
        if (istr(i) .ne. 0) then
          istr(i) = istr(i) - 1
        else 
          istr(i) = 9999
        endif
        if (iend(i) .ne. 0) then
          iend(i) = iend(i) + 1
        else 
          iend(i) = -9999
        endif
   50 continue
c
      do 60 i=1,nx
        if (jstr(i) .ne. 0) then
          jstr(i) = jstr(i) - 1
        else 
          jstr(i) = 9999
        endif
        if (jend(i) .ne. 0) then
          jend(i) = jend(i) + 1
        else 
          jend(i) = -9999
        endif
   60 continue
c
      return
      end
