c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine bndry(ustar,rb)
c
c-----ATDM v1.00
c
c     Estimates the boundary (laminar) layer resistance
c     for dry deposition using the standard relations
c
c-----95/03/09:
c     -from UAM-V Revision 1.2  94/02/10  20:50:49  tcm
c     -moved DRATIO data statement to AQBDAT block data, carry DRATIO
c      in COMCHEM
c     -simplified algorithm
c
c     Input arguments:
c               ustar:          friction velocity (m/s)
c     Output arguments:
c               rb:             array of bulk resistances (s/m)
c     Called by:
c               surlyr    srlyrf
c
      include 'parchm.cmd'
      include 'comchem.cmd'
c
      dimension rb(mxgas)
      data d1,d2,dair,vk,dh2o/2.0,0.666,1.5e-05,0.40,2.3e-05/
c
c-----Calculate a single factor for each species
c
      do 10 i = 1,ngas
          jid = jind(i)
          dfac = d1*(dair*dratio(jid)/dh2o)**d2/vk
          rb(i) = dfac/ustar
   10 continue
      return
      end
