c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
c
      subroutine chem (nospec,hh,hr,rate,rp,lerror)
      include  'parchm.cmd'
      include  'comchem.cmd'
      include  'comchem2.cmd'
      logical lerror,lin
      DIMENSION  rate(nors), rp(nors,nors)
      dimension  hh(nors), hr(mxrads)
      real noxs
c
      namesub = 'a  '
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
c     write(*,*) 'kNO, kNO2S, kO3, kNO2, kCARB, kVOC: '
c     write(*,*) kNO, kNO2S, kO3, kNO2, kCARB, kVOC
c     write(*,*) 'kPNA, kPAN, kCO, kHNO2, kH2O2, kHNO3: '
c     write(*,*) kPNA, kPAN, kCO, kHNO2, kH2O2, kHNO3
c     write(*,*) 'kNTR, kSO2, kSULF, kISOP, kTERP, kSV1: '
c     write(*,*) kNTR, kSO2, kSULF, kISOP, kTERP, kSV1
c     write(*,*) 'kSV2, kSV3, kSV4, kO1D, kO, kNO3: '
c     write(*,*) kSV2, kSV3, kSV4, kO1D, kO, kNO3
c     write(*,*) 'kN2O5, kHO2, kOH, kC2O3, kXO2, kXO2N, kROR: '
c     write(*,*) kN2O5, kHO2, kOH, kC2O3, kXO2, kXO2N, kROR
      SO2  = 0.
      SULF = 0.
      NO = HH(kNO)
      NO2S = HH(kNO2S)
      O3 = HH(kO3)
      NO2 = HH(kNO2)
      CARB = HH(kCARB)
      VOC = HH(kVOC)
      PNA = HH(kPNA)
      PAN = HH(kPAN)
      CO = HH(kCO)
      HNO2 = HH(kHNO2)
      H2O2 = HH(kH2O2)
      HNO3 = HH(kHNO3)
      IF (LNTR) NTR = HH(kNTR)
      IF (LSO2) SO2 = HH(kSO2)
      IF (LSO2) SULF = HH(kSULF)
      ISOP = HH(kISOP)
      TERP = HH(kTERP)
      SV1 = HH(kSV1)
      SV2 = HH(kSV2)
      SV3 = HH(kSV3)
      SV4 = HH(kSV4)
      O1D = HR(kO1D)
      O = HR(kO)
      NO3 = HR(kNO3)
      N2O5 = HR(kN2O5)
      HO2 = HR(kHO2)
      OH = HR(kOH)
      C2O3 = HR(kC2O3)
      XO2 = HR(kXO2)
      XO2N = HR(kXO2N)
      ROR = HR(kROR)
c
c This is radical solver routine and coded by Dongfen Gao, SAI, July 1998.
c  In this routine, the radical will be solved and the rate and
c    Jacobian for fast species will be calculated.
c
      nitmax = 50
      xtol = 0.01
      lss=.true.
c
c
c---- the radical solver now------
c
c    Solver O1D and O first.
c
      Sink =   - rk(10)  - rk(11)*H2O
      Source = 1.*rk(9)*O3
      hr(ko1d) = -Source/Sink
      o1d = hr(ko1d)
c
      Sink =   - rk(2)  - rk(4)*NO2S  - rk(5)*NO2S  - rk(6)*NO
     &   - rk(49)*CARB  - rk(64)*VOC  - rk(69)*ISOP  - rk(74)*TERP
      Source = 1.*rk(1)*NO2S +1.*rk(8)*O3 +1.*rk(10)*O1D
     &  +.89*rk(16)*NO3
      hr(ko) = -Source/Sink
      o = hr(ko)
c
c    Solve NO3 and N2O5 Next.
c
c
c   partition no3 & n2o5 from excess no2 over no2s, per gzw 11/22/00
c
      rxn     =  rk(19)*no2s / (rk(23)*h2o + rk(24))
      delnox  =  no2 - no2s
c
      if (delnox .lt. 0.) then
          delnox = 0.
      endif
      oc1  =  rk(16) + rk(17)*no + no2s*(rk(18)+ rk(19)) + rk(21)*oh
     &       + rk(22)*ho2 + rk(50)*carb + rk(63)*voc + rk(72)*isop
     &       + rk(77)*terp - rk(24)*rxn
      oc2  =  rk(5)*o*no2s + rk(7)*o3*no2s + oh*(rk(34)*pna 
     &       + rk(36)*hno3) + rk(35)*0.39*pna
      no3  =  2.*oc2 / (oc1 + sqrt(oc1*oc1 + 4.*rk(20)*oc2))
      n2o5  =  no3*rxn
      noxs  =  no3 + 2.*n2o5
      lss = .true.
      if (noxs/no2 .gt. 0.01 .or. delnox/no2 .gt. 0.01) then
        no3  =  delnox / (1. + 2.*rxn)
        n2o5  =  no3*rxn
        noxs  =  no3 + 2.*n2o5
        lss = .false.
      endif     
c
      hr(kno3) = no3
      hr(kn2o5) = n2o5
c
c---- radicals NO3 and N2O5 converged.
c     now Solve HO2, OH, C2O3, XO2, XO2N together
c
      liter = 0
      xxtol = xtol
 210  continue
      lerror=.false.
      liter = liter + 1
c
      ibeg=kho2
      iend=kxo2n
      call radjrat (nospec,hh,hr,rate,rp)
      call colpivot (ibeg,iend,nospec,rp,rate,ier)
c
      if (ier.eq.0) then
        lerror=.true.
        write(*,*) 'error in radical concentration calculation'
        write(*,*) 'in colpivot, matrix of equations is singular'
        write(*,*) 'HO2,OH,C2O3,XO2,XO2N'
        write(*,*) 'ier,liter,nitmax= ',ier,liter,nitmax
        call flush(6)
        Stop
      endif
      tmpmax = 0.
      do 220 l = ibeg,iend
        tmphr = hr(l)
        if (hr(l).gt.1.0e-9) then
           err=abs(rate(l)/hr(l))
        else
           err=abs(rate(l))
        endif
        hr(l) = tmphr - Rate(l)
        if (err.gt.tmpmax) Then
          tmpmax = err
          itmp = l
        endif
         if (hr(l).le. 0.0) hr(l)=tmphr/10.
 220  continue
c
      if (tmpmax.gt.xxtol) then
        if (liter .eq. 5) xxtol = xxtol*10.
        if (liter.le.nitmax) go to 210
        write(*,*) 'error in radical calculation in chem --'
        write(*,*) 'increase nitmax'
        write(*,*) 'ier,liter,nitmax= ',ier,liter,nitmax
        write(*,1300) (n,hr(n),n=1,mxrads)
        write(*,1400) (n,rk(n),n=1,64)
        call flush(6)
        lerror =.true.
        Stop
      endif
c
      ho2 = hr(kho2)
      oh = hr(koh)
      c2o3 = hr(kc2o3)
      xo2 = hr(kxo2)
      xo2n = hr(kxo2n)
c
c---- radicals HO2, OH, C2O3, XO2, XO2N converged.
c   and finally to Solve ROR
c
      Sink =   - rk(59)  - rk(60)  - rk(61)*NO2S
      Source = .4*rk(58)*VOC*OH +.02*rk(59)*ROR
      hr(kror) = -Source/Sink
      ror = hr(kror)
c
c---- all radicals have been solved and now we calculate
c      rate and Jacobian for fast species.
c
      call fastrate (nospec,hh,hr,rate)
      call fastjac (nospec,hh,hr,rp)
c
c
c---------formats------------------------------------------------------
 1000 format(1x,
     1         '*** error in radical concentration calculations in chem',
     2    //,2x,'       ier     liter    nitmax',/,2x,3i10)
 1300 format(1x,'    hr   ',/,(1x,i4,e12.5))
 1400 format(1x,'    rk   ',/,(1x,i4,e12.5))
 1500 format(1x,' jac--for i=  ',i3,/,(6e12.5))
c----------------------------------------------------------------------
c
      return
      end
