c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
c******************************************************************
c use column pivot method to solve the equation
c
c ****   solve linear equations by gaussian  maximum column's piovt
c
      subroutine colpivot(nbeg,nend,ndim,a,b,ier)
c
      include 'testdata.cmd'
      dimension a(ndim,ndim),b(ndim)
      data eps/1.0e-10/
c
      itest = itest + 1
      ier=1
      if (nend-nbeg+1.eq.2) then
        det = a(nbeg,nbeg)*a(nend,nend)-a(nend,nbeg)*a(nbeg,nend)
        bnbeg = b(nbeg)*a(nend,nend)-b(nend)*a(nbeg,nend)
        bnend = a(nbeg,nbeg)*b(nend)-a(nend,nbeg)*b(nbeg)
        if (det .eq. 0) then
          ier = 0
          return
        endif
        b(nbeg) = bnbeg/det
        b(nend) = bnend/det
        return
      endif
c
      if (nend-nbeg+1.eq.3) then
        det   = a(nbeg,nbeg)    *a(nbeg+1,nbeg+1)*a(nend,nend)
     &        + a(nbeg+1,nbeg)  *a(nend,nbeg+1)  *a(nbeg,nend)
     &        + a(nend,nbeg)    *a(nbeg+1,nend)  *a(nbeg,nbeg+1)
     &        - a(nend,nbeg)    *a(nbeg+1,nbeg+1)*a(nbeg,nend)
     &        - a(nend,nbeg+1)  *a(nbeg+1,nend)  *a(nbeg,nbeg)
     &        - a(nend,nend)    *a(nbeg+1,nbeg)  *a(nbeg,nbeg+1)
        bnbeg = b(nbeg)         *a(nbeg+1,nbeg+1)*a(nend,nend)
     &        + b(nbeg+1)       *a(nend,nbeg+1)  *a(nbeg,nend)
     &        + b(nend)         *a(nbeg+1,nend)  *a(nbeg,nbeg+1)
     &        - b(nend)         *a(nbeg+1,nbeg+1)*a(nbeg,nend)
     &        - a(nend,nbeg+1)  *a(nbeg+1,nend)  *b(nbeg)  
     &        - a(nend,nend)    *b(nbeg+1)       *a(nbeg,nbeg+1)
        bnbeg1= a(nbeg,nbeg)    *b(nbeg+1)       *a(nend,nend)
     &        + a(nbeg+1,nbeg)  *b(nend)         *a(nbeg,nend)
     &        + a(nend,nbeg)    *a(nbeg+1,nend)  *b(nbeg)  
     &        - a(nend,nbeg)    *b(nbeg+1)       *a(nbeg,nend)
     &        - b(nend)         *a(nbeg+1,nend)  *a(nbeg,nbeg)
     &        - a(nend,nend)    *a(nbeg+1,nbeg)  *b(nbeg)
        bnend = a(nbeg,nbeg)    *a(nbeg+1,nbeg+1)*b(nend)  
     &        + a(nbeg+1,nbeg)  *a(nend,nbeg+1)  *b(nbeg)
     &        + a(nend,nbeg)    *b(nbeg+1)       *a(nbeg,nbeg+1)
     &        - a(nend,nbeg)    *a(nbeg+1,nbeg+1)*b(nbeg)
     &        - a(nend,nbeg+1)  *b(nbeg+1)       *a(nbeg,nbeg)
     &        - b(nend)         *a(nbeg+1,nbeg)  *a(nbeg,nbeg+1)
        if (det .eq. 0) then
          ier = 0
          return
        endif
 
        b(nbeg) = bnbeg/det
        b(nbeg+1) = bnbeg1/det
        b(nend) = bnend/det
 
        return
      endif
c
      do 100 icurrnt=nbeg,nend-1
c
c ****   find the maximum element in the column
c
         alarge=0.0
         do i=icurrnt,nend
           if (alarge.lt.abs(a(i,icurrnt))) then
             alarge=abs(a(i,icurrnt))
             m=i
           endif
         enddo
c
c ****  switch the rows
c
         do j=icurrnt,nend
           temp=a(icurrnt,j)
           a(icurrnt,j)=a(m,j)
           a(m,j)=temp
         enddo
         temp=b(icurrnt)
         b(icurrnt)=b(m)
         b(m)=temp
c
c ****   check for singularity
c
 1001    format (i3, 100(1x, e10.4))
c
         if (abs(a(icurrnt,icurrnt)).le.eps) then
           write(*,*) 'in colpivot, the equations is singular', a(icurrnt,icurrnt), eps, icurrnt
           write (*,*) 'itest =', itest
           write (*,*) nbeg,nend,ndim,ier
           do i = 1, ndim
           write (*,1001) i, (a(i,j), j = 1, ndim)
           end do
           write (*,*) 
           do i = 1, ndim
              write (*,1001) i, b(i)
           end do
           write (*,*) idex,jdex,kdex,itest
           write (*,*) testtime, testidate, avetime
           return
         endif
c
c ****   gaussian reduction
c
        b(icurrnt)=b(icurrnt)/a(icurrnt,icurrnt)
        do j=nend,icurrnt,-1
          a(icurrnt,j)=a(icurrnt,j)/a(icurrnt,icurrnt)
        enddo
        do k=icurrnt+1,nend
          b(k)=b(k)-b(icurrnt)*a(k,icurrnt)
          do j=nend,icurrnt,-1
            a(k,j)=a(k,j)-a(icurrnt,j)*a(k,icurrnt)
          enddo
        enddo
c
  100 continue
c
c*****  back substitution
c
      b(nend) = b(nend)/a(nend,nend)
      do i=nend-1,nbeg,-1
        do j=i+1,nend
          b(i)=b(i)-a(i,j)*b(j)
        enddo
      enddo
c
      return
      end
