c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
c
c     COMUAM.CMD
c
c-----ATDM v1.00
c
c     Common blocks for ATDM
c
c-----95/02/22:
c     -from UAM-V Revision 1.2  94/02/10  21:03:58  tcm
c     -removed chemistry aggregation flag
c     -removed unused AHPREC array
c     -major modifications for ATDM
c-----99/03/22:dfg
c     -added a common 'dfgrad' for radical calculations.
c
	real*4 no3con
c
      common /terrain/ avterr(mxx,mxy),ctlon(mxx,mxy),ctlat(mxx,mxy)
      common /con/ conc(mxx,mxy,mxspec,mxz),bc(mxxx,4,mxspec,mxz),
     &             avgtme
      common /met1/ u(mxx,mxy,mxz)
      common /met2/ v(mxx,mxy,mxz)
      common /met4/ h(mxx,mxy,mxz),elapsth,elapstv
      common /met5/ psnew(mxx,mxy),psold(mxx,mxy),psfc(mxx,mxy),
     &              pstar(mxx,mxy)
      common /vgrid/ pmodtop,sigma(mxz+1),sigdot(mxx,mxy,mxz)
      common /difusn/ kh(mxx,mxy,mxz)
      common /rainn/ lwet,rain(mxx,mxy),wrat(mxx,mxy,mxz)
      common /grdstf/ deltax(mxy),deltay,nox,noy,nospec,noxy,
     & 		      nospc1,nlayer,tphioa(mxy),nnhg,nncd
      common /area/ qarea(mxx,mxy,mxemit),tarea(mxspec,2),
     &        larea,lpts,nemit,kemit(mxemit),naemit,kaemit(mxemit)
      common /units/ ichem,ioh1,ioh2,iwind,iprs,itemp,ih2o,iclh2o,irnh2o,
     &           isurf,iterr,edf,aem1,aem2,aem3,icbc,io3,irain,ikv,iuavg,iudep
      common /avout/ kavspc(mxspec), navspc, mavspc(mxspec)
      character*10 mavspc
      common /ground/ avcong(mxx,mxy,mxspec),coldg(mxx,mxy,mxspec)
      common /topo/ fland(mxx,mxy,mlus),lsnow(mxx,mxy),
     &              lstres(mxx,mxy)
      common /kvv/ kv(mxx,mxy,mxz),tsurf(mxx,mxy)
      common /bndry1/ istr(mxy),iend(mxy),
     &                jstr(mxx),jend(mxx)
      common /linchm/ ny,nm,nd
      common /opaque/ cloud(mxx,mxy,mxz),xmd(mxx,mxy),kcldb(mxx,mxy),
     &                kcldt(mxx,mxy),kfrz(mxx,mxy),fconv(mxx,mxy),
     &                fstrt(mxx,mxy)
      common /ambtmp/ temper(mxx,mxy,mxz),press(mxx,mxy,mxz),
     &                cfnonpr(mxx,mxy,mxz)
      common /water/ ch2o(mxx,mxy,mxz)
      common /cwmr/ clh2o(mxx,mxy,mxz),rnh2o(mxx,mxy,mxz)
      common /oxidnt/ hydro(mxx,mxy,mxz),ozone(mxx,mxy,mxz)
      common /surfac/ dt1,dt2
      common /abswnd/ aumin(mxz),aumax(mxz),auavg(mxz),avmin(mxz),
     &                avmax(mxz),avavg(mxz),
     &                avmaxj(mxx,mxz),aumaxi(mxy,mxz)
      common /dpvl/depvel(mxx,mxy,mxspec),dposit(mxx,mxy,mxspec),
     &             wposit(mxx,mxy,mxspec)
      common /idvcon/ idepv, ndvsp, kdvsp(mxspec)
      common /sedmnt/ vg(mxx,mxy,mxz,mxspec)
      common /dfgrad/ radcon(mxrads,mxx*mxy*mxz)
      common /parmoh/ ohcon(mxx,mxy,mxz),no3con(mxx,mxy,mxz),
     &              ho2con(mxx,mxy,mxz),aso2con(mxx,mxy,mxz),
     &              peccon(mxx,mxy,mxz),
     &              cl2con(mxx,mxy),nspio3,
     &              lmoh,msoh(10),msho2(10),
     &              msno3(10),msaso2(10),
     &              iohf
c
      logical lpts,larea
      logical lwet
      integer edf,aem1,aem2,aem3
c     real kh,kv,lwch2o
      real kh,kv
      logical lmoh
      character*4 msoh,msho2,msno3,msaso2
