c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
c
      SUBROUTINE fastjac(NOSPEC,HH,HR,JAC)
      INCLUDE  'parchm.cmd'
      INCLUDE  'comchem.cmd'
      INCLUDE  'comchem2.cmd'
      DIMENSION  JAC(nors,nors), HH(nors),HR(MXRADS)
      REAL JAC
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      NO = HH(KNO)
      NO2S = HH(KNO2S)
      O3 = HH(KO3)
      NO2 = HH(KNO2)
      CARB = HH(KCARB)
      VOC = HH(KVOC)
      PNA = HH(KPNA)
      PAN = HH(KPAN)
      CO = HH(KCO)
      HNO2 = HH(KHNO2)
      H2O2 = HH(KH2O2)
      HNO3 = HH(KHNO3)
      IF (LNTR) NTR = HH(KNTR)
      IF (LSO2) SO2 = HH(KSO2)
      IF (LSO2) SULF = HH(KSULF)
      ISOP = HH(KISOP)
      TERP = HH(KTERP)
      SV1 = HH(KSV1)
      SV2 = HH(KSV2)
      SV3 = HH(KSV3)
      SV4 = HH(KSV4)
      O1D = HR(KO1D)
      O = HR(KO)
      NO3 = HR(KNO3)
      N2O5 = HR(KN2O5)
      HO2 = HR(KHO2)
      OH = HR(KOH)
      C2O3 = HR(KC2O3)
      XO2 = HR(KXO2)
      XO2N = HR(KXO2N)
      ROR = HR(KROR)
c
c     *** zero out jac 
c 
       do 200 i=1,nospec
         do 100 j=1,nospec
           jac(i, j) = 0. 
 100     continue
 200   continue
c
c      Calculating the Jacobian for fast Species
c
      JAC(kNO, kNO) =  - rk(3)*O3 - rk(6)*O
     $  - rk(17)*NO3 - rk(25)*NO
     $  - rk(25)*NO - rk(25)*NO
     $  - rk(25)*NO - rk(26)*NO2S*H2O
     $  - rk(27)*OH - rk(37)*HO2
     $  - rk(38)*XO2 - rk(39)*XO2N
     $  - rk(51)*C2O3
      JAC(kNO, kNO2S) =  - rk(26)*NO*H2O +1.*rk(1)
     $  +1.*rk(4)*O +1.*rk(18)*NO3
     $  +.2*rk(73)*ISOP
      JAC(kNO, kO3) =  - rk(3)*NO
      JAC(kNO2S, kNO) =  - rk(26)*NO2S*H2O +1.*rk(3)*O3
     $  +1.*rk(6)*O +2.*rk(17)*NO3
     $  +2.*rk(25)*NO +2.*rk(25)*NO
     $  +1.*rk(37)*HO2 +1.*rk(38)*XO2
     $  +1.*rk(51)*C2O3
      JAC(kNO2S, kNO2S) =  - rk(1) - rk(4)*O
     $  - rk(5)*O - rk(7)*O3
     $  - rk(18)*NO3 - rk(19)*NO3
     $  - rk(26)*NO*H2O - rk(31)*OH
     $  - rk(32)*HO2 - rk(52)*C2O3
     $  - rk(61)*ROR - rk(73)*ISOP
     $  +1.*rk(18)*NO3
      JAC(kNO2S, kO3) =  - rk(7)*NO2S +1.*rk(3)*NO
      JAC(kO3, kNO) =  - rk(3)*O3
      JAC(kO3, kNO2S) =  - rk(7)*O3
      JAC(kO3, kO3) =  - rk(3)*NO - rk(7)*NO2S
     $  - rk(8) - rk(9)
     $  - rk(12)*OH - rk(13)*HO2
     $  - rk(62)*VOC - rk(71)*ISOP
     $  - rk(76)*TERP
      JAC(kNO2, kNO) =  +1.*rk(3)*O3 +1.*rk(6)*O
     $  +1.*rk(17)*NO3 +2.*rk(25)*NO
     $  +2.*rk(25)*NO +-1.*rk(26)*NO2S*H2O
     $  +1.*rk(37)*HO2 +1.*rk(38)*XO2
     $  +1.*rk(51)*C2O3
      JAC(kNO2, kNO2S) =  +-1.*rk(1) +-1.*rk(4)*O
     $  +-1.*rk(18)*NO3 +-1.*rk(26)*NO*H2O
     $  +-1.*rk(31)*OH +-1.*rk(32)*HO2
     $  +-1.*rk(52)*C2O3 +-1.*rk(61)*ROR
     $  +-1.*rk(73)*ISOP
      JAC(kNO2, kO3) =  +1.*rk(3)*NO
c
      RETURN
      END
