c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine fcmprt(time,ndate,ifine)
c
c-----ATDM v1.00
c
c     Prints fine grid cumulative mass flux across region boundaries
c     at the end of run 
c
c-----95/02/22:
c     -from UAM-V Revision 1.2  94/02/10  20:55:32  tcm
c     -removed output of PiG mass flux variables
c
c     Input arguments:
c               time:           model time     
c               ndate:          model date
c               ifine:          fine grid index
c     Files written:
c               8:              diagnostic file
c     Called by:
c               atdm
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'balanc.cmd'
c
c  print cumulative mass flux summary 
c  (only for species to appear on average file)
c
      write(8,2000) ifine, time, ndate
      do 400 l=1,navspc,2
        linspc = kavspc(l)
        if (l .lt. navspc) lins2 = kavspc(l+1)
        if (l .eq. navspc) then
          write(8,2010) mavspc(l)
          fnet = fbcflc(linspc,1,1,ifine) - fbcflc(linspc,2,1,ifine)
          write(8,2020) fbcflc(linspc,1,1,ifine), feflc(linspc,ifine),
     &                fbcflc(linspc,2,1,ifine), fptflc(linspc,ifine),
     &                fnet, fdpflc(linspc,ifine)
          fnetw = fbcflc(linspc,1,4,ifine) - fbcflc(linspc,2,4,ifine)
          fnett = ftpflc(linspc,1,ifine) - ftpflc(linspc,2,ifine)
          fnete = fbcflc(linspc,1,3,ifine) - fbcflc(linspc,2,3,ifine)
          write(8,2030) fbcflc(linspc,1,4,ifine), 
     &                ftpflc(linspc,1,ifine), fbcflc(linspc,1,3,ifine),
     &                fbcflc(linspc,2,4,ifine),
     &                ftpflc(linspc,2,ifine), fbcflc(linspc,2,3,ifine),
     &                fnetw, fnett, fnete
          fnet = fbcflc(linspc,1,2,ifine) - fbcflc(linspc,2,2,ifine)
          write(8,2035) fbcflc(linspc,1,2,ifine),
     &                fbcflc(linspc,2,2,ifine), ftmas(linspc,ifine), 
     &                fnet
        else
          write(8,2110) mavspc(l), mavspc(l+1)
          fnet = fbcflc(linspc,1,1,ifine) - fbcflc(linspc,2,1,ifine)
          fnet2 = fbcflc(lins2,1,1,ifine) - fbcflc(lins2,2,1,ifine)
          write(8,2120) fbcflc(linspc,1,1,ifine), feflc(linspc,ifine),
     &          fbcflc(lins2,1,1,ifine), feflc(lins2,ifine),
     &          fbcflc(linspc,2,1,ifine), fptflc(linspc,ifine),
     &          fbcflc(lins2,2,1,ifine), fptflc(lins2,ifine),
     &          fnet, fdpflc(linspc,ifine), fnet2, fdpflc(lins2,ifine)
          fnetw = fbcflc(linspc,1,4,ifine) - fbcflc(linspc,2,4,ifine)
          fnett = ftpflc(linspc,1,ifine) - ftpflc(linspc,2,ifine)
          fnete = fbcflc(linspc,1,3,ifine) - fbcflc(linspc,2,3,ifine)
          fnetw2 = fbcflc(lins2,1,4,ifine) - fbcflc(lins2,2,4,ifine)
          fnett2 = ftpflc(lins2,1,ifine) - ftpflc(lins2,2,ifine)
          fnete2 = fbcflc(lins2,1,3,ifine) - fbcflc(lins2,2,3,ifine)
          write(8,2130) fbcflc(linspc,1,4,ifine), 
     &                ftpflc(linspc,1,ifine), fbcflc(linspc,1,3,ifine),
     &                fbcflc(lins2,1,4,ifine), 
     &                ftpflc(lins2,1,ifine), fbcflc(lins2,1,3,ifine),
     &                fbcflc(linspc,2,4,ifine),
     &                ftpflc(linspc,2,ifine), fbcflc(linspc,2,3,ifine),
     &                fbcflc(lins2,2,4,ifine),
     &                ftpflc(lins2,2,ifine), fbcflc(lins2,2,3,ifine),
     &                fnetw, fnett, fnete,
     &                fnetw2, fnett2, fnete2
          fnet = fbcflc(linspc,1,2,ifine) - fbcflc(linspc,2,2,ifine)
          fnet2 = fbcflc(lins2,1,2,ifine) - fbcflc(lins2,2,2,ifine)
          write(8,2135) fbcflc(linspc,1,2,ifine), 
     &          fbcflc(lins2,1,2,ifine),
     &          fbcflc(linspc,2,2,ifine), ftmas(linspc,ifine),
     &          fbcflc(lins2,2,2,ifine), ftmas(lins2,ifine),
     &          fnet, fnet2
        endif
        write(8,2040)
  400 continue
c
      return
c
c  formats
c
 2000 format(//,1x,'Cumulative mass flux summary in moles for ',
     &       'fine grid ',i2,' at ',f8.2,i8,':',/)
 2010 format(1x,'Spec = ',a10,2x,'North')
 2020 format(13x,'In  ',1pe10.3,15x,'Srf emiss ',e10.3,/,
     &       13x,'Out ',e10.3,15x,'Elv emiss ',e10.3,/,
     &       13x,'Net ',e10.3,15x,'Depostn   ',e10.3,/)
 2030 format(8x,'West',8x,'Top',8x,'East',/,
     &       1x,'In  ',1pe10.3,2x,e10.3,2x,e10.3,/,
     &       1x,'Out ',e10.3,2x,e10.3,2x,e10.3,/,
     &       1x,'Net ',e10.3,2x,e10.3,2x,e10.3,//,
     &       20x,'South')
 2035 format(13x,'In  ',1pe10.3,/,
     &       13x,'Out ',e10.3,15x,'Tot mass  ',e10.3,/,
     &       13x,'Net ',e10.3,e10.3,/)
 2040 format(1x,126(1h-))
 2110 format(1x,'Spec = ',a10,2x,'North',38x,'| ','Spec = ',
     &       a10,2x,'North')
 2120 format(13x,'In  ',1pe10.3,15x,'Srf emiss ',e10.3,1x,'|',
     &       13x,'In  ',e10.3,15x,'Srf emiss ',e10.3,/,
     &       13x,'Out ',e10.3,15x,'Elv emiss ',e10.3,1x,'|',
     &       13x,'Out ',e10.3,15x,'Elv emiss ',e10.3,/,
     &       13x,'Net ',e10.3,15x,'Depostn   ',e10.3,1x,'|',
     &       13x,'Net ',e10.3,15x,'Depostn   ',e10.3,/,63x,'|')
 2130 format(8x,'West',8x,'Top',8x,'East',28x,'|',
     &       8x,'West',8x,'Top',8x,'East',/,
     &       1x,'In  ',1pe10.3,2x,e10.3,2x,e10.3,24x,'|',
     &       1x,'In  ',e10.3,2x,e10.3,2x,e10.3,/,
     &       1x,'Out ',e10.3,2x,e10.3,2x,e10.3,24x,'|',
     &       1x,'Out ',e10.3,2x,e10.3,2x,e10.3,/,
     &       1x,'Net ',e10.3,2x,e10.3,2x,e10.3,24x,'|',
     &       1x,'Net ',e10.3,2x,e10.3,2x,e10.3,/,
     &       63x,'|',/,20x,'South',38x,'|',20x,'South')
 2135 format(13x,'In  ',1pe10.3,36x,'|',
     &       13x,'In  ',e10.3,/,
     &       13x,'Out ',e10.3,15x,'Tot mass  ',e10.3,1x,'|',
     &       13x,'Out ',e10.3,15x,'Tot mass  ',e10.3,/,
     &       13x,'Net ',e10.3,36x,'|',
     &       13x,'Net ',e10.3,/,63x,'|')
      end
