c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine fgmax_04(nxf,nyf,nzf,uf,vf,umaxi,vmaxj)
c
c-----ATDM v1.00
c
c     Calculates maximum u and v components on a fine grid
c
c-----95/06/15:
c     -from UAM-V Revision 1.2  94/02/10  20:55:40  tcm
c
c     Input arguments:
c               nxf:            number of fine grid cells in x-direction      
c               nyf:            number of fine grid cells in y-direction      
c               nzf:            number of fine grid layers
c               uf:             array of x-component windspeeds (km/min)
c               vf:             array of y-component windspeeds (km/min)
c     Output arguments:
c               umax:           maximum x-component windspeed (km/min)
c               vmax:           maximum y-component windspeed (km/min)
c
c     Called by:
c               fstep
c
      include 'parfin.cmd'
c
      real umaxi(mxfy,mxfz),vmaxj(mxfx,mxfz)
      dimension uf(nxf,nyf,nzf), vf(nxf,nyf,nzf)
c
c  calculate maximum absolute x and y component of wind speed
c
c      umax = -999.
c      vmax = -999.
      do 100 k=1,nzf
        do 90 j=2,nyf-1
          do 80 i=2,nxf-1
            umaxi(j,k) = amax1(abs(uf(i,j,k)),umaxi(j,k))
            vmaxj(i,k) = amax1(abs(vf(i,j,k)),vmaxj(i,k))
   80     continue
   90   continue
  100 continue
c
      return
      end
