c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine fgread(iunit,nxf,nyf,nzf,nfspec,cncf)
c
c-----ATDM v1.00
c
c     Reads instantaneous fine grid concs from binary file
c
c-----95/06/01:
c     -from UAM-V Revision 1.2  94/02/10  20:55:44  tcm
c
c     Input arguments:
c               iunit:          fine grid instantaneous file unit number
c               nxf:            number of fine grid cells in x-direction
c               nyf:            number of fine grid cells in y-direction
c               nzf:            number of fine grid layers 
c               nfspec:         number of modeled species
c     Output arguments:
c               cncf:           fine grid concentrations (ppm)
c     Files read:
c               iunit:          fine grid instantaneous file
c     Files written:
c               6:              standard output file unit (*)
c     Called by:
c               restrt
c
      dimension cncf(nxf,nyf,nfspec,nzf)
c
      write (*,*) 'in the begining of fgread'
      do 100 l=1,nfspec
        do 90 k=1,nzf
          read(iunit,iostat=irst) ((cncf(i,j,l,k),i=1,nxf),j=1,nyf)
          if (irst .ne. 0) then 
            backspace iunit
            write(*,*) ' Error on fine grid conc record, backing up'
          endif
   90   continue
  100 continue
      return
      end
