c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine gunit(iunit,time,ndate)
c
c-----ATDM v1.00
c
c     Returns unit for area source emissions file
c     depending on day of week
c
c-----95/06/01:
c     -from UAM-V Revision 1.2  94/02/10  20:56:53  tcm
c
c     iunit = aem1 weekday
c     iunit = aem2 saturday
c     iunit = aem3 sunday
c
c     Input arguments:
c               time:           model time    
c               ndate:          model date 
c     Output arguments:
c               iunit:          area source emission file unit
c     Routines called:
c               jtocal    zellar
c     Called by:
c               atdm      setup
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
c
      iunit=aem1
      if (ndate .lt. 100000) then
        call jtocal(ndate,icdate)
        nyr=icdate/10000
        nmth=icdate/100-nyr*100
        nday=icdate-nmth*100-nyr*10000
      else
        nyr=ndate/10000
        nmth=ndate/100-nyr*100
        nday=ndate-nmth*100-nyr*10000
      endif
      nyr = nyr + 1900
c
      if (time.gt.2398.0) nday=nday+1
      call zellar(nyr,nmth,nday,idofwk)
      if (idofwk.gt.2) return
      if (idofwk.eq.1) iunit=aem2
      if (idofwk.eq.2) iunit=aem3
      return
      end
