c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine jtocal(jdate,idate)
c
c-----ATDM v1.00
c
c     Converts a five digit Julian date to YYMMDD type date
c
c-----95/06/01:
c     -from UAM-V Revision 1.2  94/02/10  20:57:40  tcm
c
c     Input arguments:
c               jdate:          Julian date
c     Output arguments:
c               idate:          date in YYMMDD 
c     Called by:
c               chkdat    getbc     getic     getpt     getqar    gunit
c               rchem     rchemf    surlyr    srlyrf    update 
c
      dimension ntab(12)
      data ntab/31,28,31,30,31,30,31,31,30,31,30,31/
c
      iyr = jdate/1000
      nday = jdate - iyr*1000
c     
      if (mod(iyr,4) .eq. 0 .and. mod(iyr,100) .ne. 0) then
        ntab(2) = 29
      else
        ntab(2) = 28
      endif
c
      nsum = 0
      do 100 ii=1,12
        imo = ii
        nsum = nsum + ntab(imo)
        if (nsum .ge. nday) go to 120
  100 continue
c
  120 nsm1 = nsum - ntab(imo)
      idy = nday - nsm1
c     
      idate = iyr*10000 + imo*100 + idy
      return
      end
