c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
c
      SUBROUTINE RADJRAT(NOSPEC,HH,HR,RATE, JAC)
      INCLUDE  'parchm.cmd'
      INCLUDE  'comchem.cmd'
      INCLUDE  'comchem2.cmd'
      DIMENSION  RATE(nors), HH(nors), HR(MXRADS)
      DIMENSION  JAC(nors,nors)
      REAL JAC
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      NO = HH(KNO)
      NO2S = HH(KNO2S)
      O3 = HH(KO3)
      NO2 = HH(KNO2)
      CARB = HH(KCARB)
      VOC = HH(KVOC)
      PNA = HH(KPNA)
      PAN = HH(KPAN)
      CO = HH(KCO)
      HNO2 = HH(KHNO2)
      H2O2 = HH(KH2O2)
      HNO3 = HH(KHNO3)
      IF (LNTR) NTR = HH(KNTR)
      IF (LSO2) SO2 = HH(KSO2)
      IF (LSO2) SULF = HH(KSULF)
      ISOP = HH(KISOP)
      TERP = HH(KTERP)
      SV1 = HH(KSV1)
      SV2 = HH(KSV2)
      SV3 = HH(KSV3)
      SV4 = HH(KSV4)
      O1D = HR(KO1D)
      O = HR(KO)
      NO3 = HR(KNO3)
      N2O5 = HR(KN2O5)
      HO2 = HR(KHO2)
      OH = HR(KOH)
      C2O3 = HR(KC2O3)
      XO2 = HR(KXO2)
      XO2N = HR(KXO2N)
      ROR = HR(KROR)
c
c     *** zero out rate and jac for radical species
c 
       do 200 i=1,nospec
         rate(i) = 0. 
         do 100 j=1,nospec
           jac(i, j) = 0. 
 100     continue
 200   continue
c
c      Calculating the rates for rad Species
c
      Sink =   - rk(10)  - rk(11)*H2O
      Source = 1.*rk(9)*O3
      Rate(kO1D) = Source + Sink*O1D
      Sink =   - rk(2)  - rk(4)*NO2S  - rk(5)*NO2S
     &   - rk(6)*NO  - rk(49)*CARB  - rk(64)*VOC
     &   - rk(69)*ISOP  - rk(74)*TERP
      Source = 1.*rk(1)*NO2S +1.*rk(8)*O3
     &  +1.*rk(10)*O1D +.89*rk(16)*NO3
      Rate(kO) = Source + Sink*O
      Sink =   - rk(16)  - rk(17)*NO  - rk(18)*NO2S
     &   - rk(19)*NO2S  - rk(20)*NO3  - rk(20)*NO3
     &   - rk(21)*OH  - rk(22)*HO2  - rk(50)*CARB
     &   - rk(63)*VOC  - rk(72)*ISOP  - rk(77)*TERP
      Source = 1.*rk(5)*O*NO2S +1.*rk(7)*NO2S*O3
     &  +1.*rk(24)*N2O5 +1.*rk(34)*OH*PNA
     &  +.39*rk(35)*PNA +1.*rk(36)*OH*HNO3
      Rate(kNO3) = Source + Sink*NO3
      Sink =   - rk(23)*H2O  - rk(24)
      Source = 1.*rk(19)*NO3*NO2S
      Rate(kN2O5) = Source + Sink*N2O5
      Sink =   - rk(13)*O3  - rk(14)*OH  - rk(22)*NO3
     &   - rk(32)*NO2S  - rk(37)*NO  - rk(41)*HO2
     &   - rk(41)*HO2  - rk(42)*HO2  - rk(42)*HO2
     &   - rk(55)*C2O3  - rk(56)*XO2  - rk(66)*XO2N
      Source = 1.*rk(12)*O3*OH +1.*rk(15)*OH
     &  +1.*rk(21)*NO3*OH +1.*rk(33)*PNA
     &  +.61*rk(35)*PNA +1.*rk(44)*OH*H2O2
     &  +1.*rk(45)*OH*CO +.3*rk(46)*CARB*OH
     &  +2.*rk(47)*CARB +1.*rk(49)*CARB*O
     &  +1.*rk(50)*CARB*NO3 +1.*rk(51)*C2O3*NO
     &  +2.*rk(54)*C2O3*C2O3 +.79*rk(55)*C2O3*HO2
     &  +1.*rk(57)*OH +.25*rk(58)*VOC*OH
     &  +.94*rk(59)*ROR +1.*rk(60)*ROR
     &  +.3*rk(62)*VOC*O3 +1.*rk(64)*VOC*O
     &  +1.*rk(65)*OH*SO2 +.25*rk(69)*ISOP*O
     &  +.91*rk(70)*ISOP*OH +.066*rk(71)*ISOP*O3
     &  +.8*rk(72)*ISOP*NO3 +.8*rk(73)*ISOP*NO2S
     &  +.75*rk(75)*TERP*OH +.065*rk(76)*TERP*O3
     &  +.526*rk(77)*TERP*NO3
      Rate(kHO2) = Source + Sink*HO2
      Sink =   - rk(12)*O3  - rk(14)*HO2  - rk(15)
     &   - rk(21)*NO3  - rk(27)*NO  - rk(29)*HNO2
     &   - rk(31)*NO2S  - rk(34)*PNA  - rk(36)*HNO3
     &   - rk(44)*H2O2  - rk(45)*CO  - rk(46)*CARB
     &   - rk(57)  - rk(58)*VOC  - rk(65)*SO2
     &   - rk(70)*ISOP  - rk(75)*TERP
      Source = 2.*rk(11)*O1D*H2O +1.*rk(13)*O3*HO2
     &  +1.*rk(28)*HNO2 +.39*rk(35)*PNA
     &  +1.*rk(37)*HO2*NO +2.*rk(43)*H2O2
     &  +1.*rk(49)*CARB*O +.79*rk(55)*C2O3*HO2
     &  +.05*rk(62)*VOC*O3 +.266*rk(71)*ISOP*O3
     &  +.567*rk(76)*TERP*O3
      Rate(kOH) = Source + Sink*OH
      Sink =   - rk(51)*NO  - rk(52)*NO2S  - rk(54)*C2O3
     &   - rk(54)*C2O3  - rk(55)*HO2
      Source = .7*rk(46)*CARB*OH +1.*rk(53)*PAN
     &  +.08*rk(58)*VOC*OH +.25*rk(69)*ISOP*O
     &  +.2*rk(71)*ISOP*O3 +.386*rk(76)*TERP*O3
      Rate(kC2O3) = Source + Sink*C2O3
      Sink =   - rk(38)*NO  - rk(40)*XO2  - rk(40)*XO2
     &   - rk(56)*HO2  - rk(68)*XO2N
      Source = 1.*rk(51)*C2O3*NO +2.*rk(54)*C2O3*C2O3
     &  +.79*rk(55)*C2O3*HO2 +1.*rk(57)*OH
     &  +.9*rk(58)*VOC*OH +.96*rk(59)*ROR
     &  +.1*rk(62)*VOC*O3 +1.*rk(63)*VOC*NO3
     &  +.5*rk(64)*VOC*O +.25*rk(69)*ISOP*O
     &  +1.*rk(70)*ISOP*OH +.2*rk(71)*ISOP*O3
     &  +1.*rk(72)*ISOP*NO3 +1.*rk(73)*ISOP*NO2S
     &  +1.25*rk(75)*TERP*OH +.76*rk(76)*TERP*O3
     &  +1.026*rk(77)*TERP*NO3
      Rate(kXO2) = Source + Sink*XO2
      Sink =   - rk(39)*NO  - rk(66)*HO2  - rk(67)*XO2N
     &   - rk(67)*XO2N  - rk(68)*XO2
      Source = .1*rk(58)*VOC*OH +.04*rk(59)*ROR
     &  +.09*rk(70)*ISOP*OH +.25*rk(75)*TERP*OH
     &  +.18*rk(76)*TERP*O3 +.25*rk(77)*TERP*NO3
      Rate(kXO2N) = Source + Sink*XO2N
      Sink =   - rk(59)  - rk(60)  - rk(61)*NO2S
      Source = .4*rk(58)*VOC*OH +.02*rk(59)*ROR
      Rate(kROR) = Source + Sink*ROR
c
c--------Now calculate the Jacobian for radicals.
c
      JAC(kO1D, kO1D) =  - rk(10) - rk(11)*H2O
      JAC(kO, kO1D) =  +1.*rk(10)
      JAC(kO, kO) =  - rk(2) - rk(4)*NO2S
     $  - rk(5)*NO2S - rk(6)*NO
     $  - rk(49)*CARB - rk(64)*VOC
     $  - rk(69)*ISOP - rk(74)*TERP
      JAC(kO, kNO3) =  +.89*rk(16)
      JAC(kNO3, kO) =  +1.*rk(5)*NO2S
      JAC(kNO3, kNO3) =  - rk(16) - rk(17)*NO
     $  - rk(18)*NO2S - rk(19)*NO2S
     $  - rk(20)*NO3 - rk(20)*NO3
     $  - rk(20)*NO3 - rk(20)*NO3
     $  - rk(21)*OH - rk(22)*HO2
     $  - rk(50)*CARB - rk(63)*VOC
     $  - rk(72)*ISOP - rk(77)*TERP
      JAC(kNO3, kN2O5) =  +1.*rk(24)
      JAC(kNO3, kHO2) =  - rk(22)*NO3
      JAC(kNO3, kOH) =  - rk(21)*NO3 +1.*rk(34)*PNA
     $  +1.*rk(36)*HNO3
      JAC(kN2O5, kNO3) =  +1.*rk(19)*NO2S
      JAC(kN2O5, kN2O5) =  - rk(23)*H2O - rk(24)
      JAC(kHO2, kO) =  +1.*rk(49)*CARB +1.*rk(64)*VOC
     $  +.25*rk(69)*ISOP
      JAC(kHO2, kNO3) =  - rk(22)*HO2 +1.*rk(21)*OH
     $  +1.*rk(50)*CARB +.8*rk(72)*ISOP
     $  +.526*rk(77)*TERP
      JAC(kHO2, kHO2) =  - rk(13)*O3 - rk(14)*OH
     $  - rk(22)*NO3 - rk(32)*NO2S
     $  - rk(37)*NO - rk(41)*HO2
     $  - rk(41)*HO2 - rk(41)*HO2
     $  - rk(41)*HO2 - rk(42)*HO2
     $  - rk(42)*HO2 - rk(42)*HO2
     $  - rk(42)*HO2 - rk(55)*C2O3
     $  - rk(56)*XO2 - rk(66)*XO2N
     $  +.79*rk(55)*C2O3
      JAC(kHO2, kOH) =  - rk(14)*HO2 +1.*rk(12)*O3
     $  +1.*rk(15) +1.*rk(21)*NO3
     $  +1.*rk(44)*H2O2 +1.*rk(45)*CO
     $  +.3*rk(46)*CARB +1.*rk(57)
     $  +.25*rk(58)*VOC +1.*rk(65)*SO2
     $  +.91*rk(70)*ISOP +.75*rk(75)*TERP
      JAC(kHO2, kC2O3) =  - rk(55)*HO2 +1.*rk(51)*NO
     $  +2.*rk(54)*C2O3 +2.*rk(54)*C2O3
     $  +.79*rk(55)*HO2
      JAC(kHO2, kXO2) =  - rk(56)*HO2
      JAC(kHO2, kXO2N) =  - rk(66)*HO2
      JAC(kHO2, kROR) =  +.94*rk(59) +1.*rk(60)
      JAC(kOH, kO1D) =  +2.*rk(11)*H2O
      JAC(kOH, kO) =  +1.*rk(49)*CARB
      JAC(kOH, kNO3) =  - rk(21)*OH
      JAC(kOH, kHO2) =  - rk(14)*OH +1.*rk(13)*O3
     $  +1.*rk(37)*NO +.79*rk(55)*C2O3
      JAC(kOH, kOH) =  - rk(12)*O3 - rk(14)*HO2
     $  - rk(15) - rk(21)*NO3
     $  - rk(27)*NO - rk(29)*HNO2
     $  - rk(31)*NO2S - rk(34)*PNA
     $  - rk(36)*HNO3 - rk(44)*H2O2
     $  - rk(45)*CO - rk(46)*CARB
     $  - rk(57) - rk(58)*VOC
     $  - rk(65)*SO2 - rk(70)*ISOP
     $  - rk(75)*TERP
      JAC(kOH, kC2O3) =  +.79*rk(55)*HO2
      JAC(kC2O3, kO) =  +.25*rk(69)*ISOP
      JAC(kC2O3, kHO2) =  - rk(55)*C2O3
      JAC(kC2O3, kOH) =  +.7*rk(46)*CARB +.08*rk(58)*VOC
      JAC(kC2O3, kC2O3) =  - rk(51)*NO - rk(52)*NO2S
     $  - rk(54)*C2O3 - rk(54)*C2O3
     $  - rk(54)*C2O3 - rk(54)*C2O3
     $  - rk(55)*HO2
      JAC(kXO2, kO) =  +.5*rk(64)*VOC +.25*rk(69)*ISOP
      JAC(kXO2, kNO3) =  +1.*rk(63)*VOC +1.*rk(72)*ISOP
     $  +1.026*rk(77)*TERP
      JAC(kXO2, kHO2) =  - rk(56)*XO2 +.79*rk(55)*C2O3
      JAC(kXO2, kOH) =  +1.*rk(57) +.9*rk(58)*VOC
     $  +1.*rk(70)*ISOP +1.25*rk(75)*TERP
      JAC(kXO2, kC2O3) =  +1.*rk(51)*NO +2.*rk(54)*C2O3
     $  +2.*rk(54)*C2O3 +.79*rk(55)*HO2
      JAC(kXO2, kXO2) =  - rk(38)*NO - rk(40)*XO2
     $  - rk(40)*XO2 - rk(40)*XO2
     $  - rk(40)*XO2 - rk(56)*HO2
     $  - rk(68)*XO2N
      JAC(kXO2, kXO2N) =  - rk(68)*XO2
      JAC(kXO2, kROR) =  +.96*rk(59)
      JAC(kXO2N, kNO3) =  +.25*rk(77)*TERP
      JAC(kXO2N, kHO2) =  - rk(66)*XO2N
      JAC(kXO2N, kOH) =  +.1*rk(58)*VOC +.09*rk(70)*ISOP
     $  +.25*rk(75)*TERP
      JAC(kXO2N, kXO2) =  - rk(68)*XO2N
      JAC(kXO2N, kXO2N) =  - rk(39)*NO - rk(66)*HO2
     $  - rk(67)*XO2N - rk(67)*XO2N
     $  - rk(67)*XO2N - rk(67)*XO2N
     $  - rk(68)*XO2
      JAC(kXO2N, kROR) =  +.04*rk(59)
      JAC(kROR, kOH) =  +.4*rk(58)*VOC
      JAC(kROR, kROR) =  - rk(59) - rk(60)
     $  - rk(61)*NO2S +.02*rk(59)
c
      RETURN
      END
