c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine rdfprs(tfdata,ifdate,nxf,nyf,ifmun,psnewf)
c
c-----ATDM v1.00
c
c     Reads one time interval of a fine grid surface pressure file
c
c-----95/06/02:
c     C Emery SAI
c
c     Input arguments:
c               nxf:            number of fine grid cells in x-direction
c               nyf:            number of fine grid cells in y-direction
c               ifmun:          fine grid surface pressure file unit number
c     Output arguments:
c               tfdata:         time from surface pressure file     
c               ifdate:         date from surface pressure file
c               psnewf:         array of surface pressure (mb)
c     Files read:
c               ifmun:          fine grid surface pressure file
c     Called by:
c               update
c
      dimension psnewf(nxf,nyf)
c
      read(ifmun) tfdata, ifdate, ((psnewf(i,j),i=1,nxf),j=1,nyf)
c
      return
      end
