c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine rdfwnd(nxf,nyf,nzf,ifmun,uf,vf)
c
c-----ATDM v1.00
c
c     Reads one time interval from fine grid wind file
c
c-----95/06/02:
c     -from UAM-V Revision 1.2  94/02/10  20:59:39  tcm
c     -removed read of wfsrf
c
c     Input arguments:
c               nxf:            number of fine grid cells in x-direction
c               nyf:            number of fine grid cells in y-direction
c               nzf:            number of fine grid layers
c               ifmun:          fine grid wind file unit number 
c     Output arguments:
c               uf:             array of u-component windspeeds (km/min)
c               vf:             array of v-component windspeeds (km/min) 
c     Files read:
c               ifmun:          fine grid wind file
c     Files written:
c               6:              standard output file unit (*)
c     Called by:
c               update
c
      dimension uf(nxf,nyf,nzf), vf(nxf,nyf,nzf)
c
      do 55 k=1,nzf
        read(ifmun) ((uf(i,j,k),i=1,nxf),j=1,nyf)
        read(ifmun) ((vf(i,j,k),i=1,nxf),j=1,nyf)
c
c     convert u & v from m/sec to km/min
c
        do 52 j=1,nyf
          do 50 i=1,nxf
            uf(i,j,k) = uf(i,j,k)*.06
            vf(i,j,k) = vf(i,j,k)*.06
   50     continue
   52   continue
   55 continue
c
      return
      end
