c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine reducr(i1in,i2in,i1out,i2out)
c
c-----ATDM v1.00
c
c     Removes all common factors (up to 100) from i1in and i2in and
c     returns in i1out and i2out
c
c-----95/06/02:
c     -from UAM-V Revision 1.4  94/07/27  09:40:19  tcm
c
c     Input arguments:
c               i1in:           first input integer    
c               i2in:           second input integer
c     Output arguments:
c               i1out:          first output integer
c               i2out:          second output integer
c     Called by:
c               ffgtrp
c
      dimension iprim(25)
      data nprim /25/
      data iprim /2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,
     &           53, 59, 61, 67, 71, 73, 79, 83, 89, 97/
c
      iw1 = i1in
      iw2 = i2in
      n = 1
c
   50 if (n .gt. nprim) go to 100
        if (iw1 .lt. iprim(n) .or. iw2 .lt. iprim(n)) go to 100
        if (mod(iw1,iprim(n)) .eq. 0 .and. 
     &      mod(iw2,iprim(n)) .eq. 0) then
          iw1 = iw1/iprim(n)
          iw2 = iw2/iprim(n)
        else
          n = n + 1
        endif
        go to 50
c
  100 i1out = iw1
      i2out = iw2
      return
      end
