c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine sedrat(d,rho,rhoair,vsed)
c
c-----ATDM v1.00
c
c     Estimates the sedimentation velocity of particles
c
c-----95/06/05:
c     -from UAM-V Revision 1.2  94/02/10  20:59:59  tcm
c     -cleaned up unused data statements
c     -added rhoair to argument list
c
c     Input arguments:
c               d:              particle diameter (m)
c               rho:            particle density (g/m3)
c               rhoair:         air density (g/m3)
c     Output arguments:
c               vsed:           sedimenation velocity (m/s)
c     Called by: 
c               partsed   partdep
c
      data a1,a2,a3,xmean/1.257,0.40,0.55,6.53e-08/
      data xmu/1.83e-02/
      data grav/9.8/
c
      cc=1.+(2*xmean/d)*(a1 + a2*exp(-a3*d/xmean))
      vsed = grav*d**2*(rho - rhoair)*cc/(18.*xmu)
      return
      end
