c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
c
c     STACK.CMD
c
c-----ATDM v1.00
c
c     Parameters for point sources
c
c-----95/02/22:
c     -from UAM-V Revision 1.3  94/08/04  14:30:34  tcm
c     -renamed PLONG to PLON
c     -Added PTSRCX and PTSRCY to common deck (see hedpts)
c     -removed PiG-related parameters
c
c     stkht  -- stack height in meters
c       
c     stkd   -- stack diameter in meters.
c
c     temps  -- stack temperature in degrees k
c
c     vexit  -- stack exit velocity internally in meters/second,
c               converted from meters/hour entered in input file.
c
c     ptemis -- emissions rates for each emitted species in
c               moles/min internally, converted from moles/hour
c               on input file.
c
c     plon, plat -- location of source in longitude and latitude
c                   or in UTM coordinates 
c
c     ptsrcx, ptsrcy -- location of point sources in grid units
c
c     heff   -- effective plume height in meters calculated 
c               internally by beh084
c
c     flowrat -- volumetric flow rate (m3/hr)
c
c     nopts  -- number of point sources
c
      common /stack/ stkht(mxsrc),stkd(mxsrc),temps(mxsrc),
     &               vexit(mxsrc),ptemis(mxemit,mxsrc), 
     &               plon(mxsrc),plat(mxsrc),ptsrcx(mxsrc),
     &               ptsrcy(mxsrc),heff(mxsrc), flowrat(mxsrc), nopts
c
