c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine stoke(d,vsed,ustar,st)
c
c-----ATDM v1.00
c
c     Estimates the stokes number
c
c-----95/06/06:
c     -from UAM-V Revision 1.2  94/02/10  21:01:30  tcm
c     -cleaned up some unused code
c
c     Input arguments:
c               d:              diameter of the particle (m)
c               vsed:           stokes sedimentation velocity (m/s)
c               ustar:          friction velocity (m/s)
c     Output arguments:
c               st:             stokes number
c     Called by:
c               partdep
c
      data a1,a2,a3,xmean,visc/1.257,0.40,0.55,6.53e-08,1.5e-05/
      data grav/9.8/
c
      cc = 1.+(2*xmean/d)*(a1 + a2*exp(-a3*d/xmean))
      st = vsed*ustar**2/(grav*cc*visc)
      return
      end
