c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine tdrate (temp,pres)
c
c-----ATDM
c     96/09/12:dfg
c     -from UAM-V Revision 1.2  94/02/10  21:01:46  tcm
c     -clean up and interpolating both rate constants and aqueous rates.
c     -delete nreact as argument. 
c
c--input variables
c         temp      r  temp
c         pres      r  pressure
c
c--output variables
c         rk        r  calculated gas phase rate constants
c         aqrk1     r  calculated aqueous phase rate constants
c         aqrk2     r  calculated aqueous phase rate constants
c         kt        r  calculated equilibrium constants
c
c--local variables
c         tterm     r  -(1/tcell - 1/tref)
c
c--routines called
c         none
c
c--called by
c         micsurf rchem
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'com3.cmd'
      include 'comtdr.cmd'
c
c***********************************************************************
c     Use calculated look-up rate constant table to get the rate
c     constant for this cell through interpolations.
c
c     *** adjust rate constants for temperature and pressure
c
cdiag
c     write(*,*) 'just enter tdrate'
c     call flush(6)
c
      temp = amax1(200.,temp)
      it = aint(temp)
      tcol = float(it) + 1.
      it = it -199
c
c      do 250 i=1,nreact
c        if (lphot(i)) go to 250
c        delk = rkt(it,i) - rkt(it-1,i)
c        delt = tcol - temp
c        rk(i) = rkt(it,i) - delt*delk
c  250 continue
c
c  calculate new equilibrium constant values
c
      do 500 i= 1, naqeq
        delk = ktt(it,i) - ktt(it-1,i)
        delk1 = aqrkt1(it,i) - aqrkt1(it-1,i)
        delk2 = aqrkt2(it,i) - aqrkt2(it-1,i)
        delt = tcol - temp 
        kt(i) = ktt(it,i) - delt*delk
        aqrk1(i) = aqrkt1(it,i) - delt*delk1
        aqrk2(i) = aqrkt2(it,i) - delt*delk2
c        if (i.eq.32) then
c          write (*,*) 'tdrate=',kt(i),aqrk1(i),aqrk2(i),delt,delk,ktt(it,i),it
c        end if
  500 continue
c     
cdiag
c     write(*,*) 'leave tdrate'
c     call flush(6)
c
      return
      end
c
