c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine tirate 
c
c----ATDM 
c    Calculate rate constant and equlibrium constants.
c    96/09/12:dfg
c    -from  UAM-V  Revision 1.2  94/02/10  21:01:59  tcm
c    -added two set of aqueous phase rate constants calculations.
c  
c--input variables
c         nreact    i  no of gas phase reactions
c
c--output variables
c         rkt       r  calculated gas phase rate constants
c         aqrkt1    r  calculated aqueous phase rate constants
c         aqrkt2    r  calculated aqueous phase rate constants
c         ktt       r  calculated equilibrium constants
c
c--local variables
c         tterm     r  -(1/tcell - 1/tref)
c
c--routines called
c         none
c
c--called by
c         atdm
c
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'com3.cmd'
      include 'comtdr.cmd'
c
c***********************************************************************
c
c     ***  produce lookup table for temperature-dependent rate constants
c
c            rk = rkn * exp(-(1/t - 1/298)*acten)
c
c
      dimension rk3(mxgrx)
c
c
      do 600 it = 1,150
        temp = it + 199.
        tterm = 1./298. - 1./temp
c
c        do 250 i=1,nreact
c          if (lphot(i)) goto 250
c          if ((.not.ltdep(i)).or.(temp.eq.298)) then
c            rkt(it,i) = rkn(i)
c          else 
c            rkt(it,i) = rkn(i) * exp(acten(i)*tterm)
c          endif
c  250   continue
c
c  calculate new equilibrium constant values
c
  450   do 500 i= 1, naqeq
          ktt(it,i) = k0(i) * exp(dhor(i)*tterm)
          aqrkt1(it,i) = kaq1(i) * exp(tkaq1(i)*tterm)
          aqrkt2(it,i) = kaq2(i) * exp(tkaq2(i)*tterm)
c          if (i .eq. 32) then
c             write (*,*) 'tirate=', it, ktt(it,i),aqrkt1(it,i),aqrkt2(it,i),k0(i),dhor(i),tterm,kaq1(i),kaq2(i)
c          end if
  500   continue
c
  600 continue
c
      return
      end
