c
c     Copyright 1996, 2001 Systems Applications International
c       The REMSAD modeling system software is the property of SAI
c       and is protected by registered copyrights. Distribution of
c       the software outside of your organization is not permitted.
c       Preparation and distribution of any derivative software using
c       any portions of the REMSAD code, without the express permission
c       of SAI, is also not permitted. By accepting the REMSAD code
c       provided in this release, you are also accepting the
c       limitations, terms, and provisions of use as noted above.
      subroutine zellar(iyr,imth,iday,idofwk)
c
c-----ATDM v1.00
c
c     Returns day of week given gregorian date
c
c-----95/06/01:
c     -from UAM-V Revision 1.2  94/02/10  21:03:20  tcm
c
c     Input arguments:
c               iyr:            year (four digits)
c               imth:           month
c               iday            day of month
c     Output arguments:
c               idofwk:        = 1 (saturday)
c                              = 2 (sunday)
c                              = 3 (monday)
c                              ...
c                              = 7 (friday)
c     Called by:
c               gunit
c
      if (imth.lt.3) then
        imo = imth + 12
        iyear = iyr -1
      else
        imo = imth
        iyear = iyr
      endif
c
      it = iday + 2*imo + 2 + (3*imo+3)/5 + iyear + iyear/4 - iyear/100
     &                + iyear/400
      idofwk = mod(it,7) + 1
c
      return
      end
